/*******************************************************************************
 Autor: Ulli Sommer
 Drive the best Way
*******************************************************************************/

int Index;
word Position[11], Distance;
byte Best_direction;


void main(void)
{

  //Hardware Initialisierung
  PRO_BOT128_INIT();
  DRIVE_ON();
  ENC_LED_ON();

  //Endlosschleife
  do
  {

    //Ultraschallsensor auslesen und bewerten
    Distance=READ_SRF02(0xE0);
    if(Distance<40)
    {
       MAPPING();
    }
    else
    {
       DRIVE_FWD(180,0);
    }

  } while(1);

}


void MAPPING(void)
{

    //Stopp Beep
    MOTOR_STOP();
    BEEP(150,200);

    //rckwrts 500mSekunden
    DRIVE_BWD(160,5);

    //Stopp
    MOTOR_STOP();
    DELAY_MS(500);

    //Entfernungswerte ins Array ablegen
    for(Index=0;Index<4;Index++)
    {
        TURN_RIGHT(145,0);
        DELAY_MS(150);
        Distance=READ_SRF02(0xE0); //ca. 100ms
        Position[Index]=Distance;
    }

    //Stopp
    MOTOR_STOP();
    DELAY_MS(500);

    //Grte Entfernung ber Arrayvergleich suchen
    Best_direction=5;
    for(Index=0;Index<4;Index++)
    {
        if(Position[Index]>Position[Best_direction])
        {
           Best_direction=Index;
        }
    }

    //Ist der beste Wert im Index 5 dann weiter gerade aus
    if(Best_direction==5)goto ende;

    //Werte umdrehen (Drehsinn)
    Best_direction=5-Best_direction;

    //Zum besten Entfernungswert ausrichten
    for(Index=0;Index<Best_direction;Index++)
    {
        TURN_LEFT(145,0);
        DELAY_MS(150);
        Distance=READ_SRF02(0xE0);  //ca. 100ms
    }

    //Stopp
    MOTOR_STOP();
    DELAY_MS(250);

   //Und weiter gehts
   ende:

}

