/*******************************************************************************
 Autor: Ulli Sommer
 Kompass Beispiel
 Kompass evtl. zuvor kalibrieren!
 Siehe Anleitung zum kompass.
 Funktionen zum Kalibrieren: CAL_CMPS03() ; SAVE_CAL_CMPS03()
*******************************************************************************/

void main(void)
{
    PRO_BOT128_INIT();
    DRIVE_ON();
    ENC_LED_ON();

    //Tonfolge
    BEEP(150,650);

    //Nach 180 (Sden) ausrichten, Speed = 135, 1Sek. warten bis ende
    KOMPASS_TURN(180,135,1000);

    //Fahre 3 Sekunden in diese Richtung
    DRIVE_FWD(180,30);

    //Tonfolge
    BEEP(150,200);
    BEEP(250,100);
    BEEP(350,200);

}


void KOMPASS_TURN(int deg, byte speed, int return_wait)
{

  int Deg_diff;
  byte Move;

  do
  {

    Move=0;

    //Differenz zwischen Soll und Ist-Winkel bilden
    Deg_diff=deg-READ_CMPS03();

          //rechts drehen
          if((Deg_diff>2)&&(Deg_diff<180))
          {
              TURN_RIGHT(speed,0);
              Move=1;
          }

          if((Deg_diff<-181)&&(Deg_diff>-358))
          {
              TURN_RIGHT(speed,0);
              Move=1;
          }

          //links drehen
          if((Deg_diff>179)&&(Deg_diff<358))
          {
              TURN_LEFT(speed,0);
              Move=1;
          }

          if((Deg_diff<-2)&&(Deg_diff>-180))
          {
              TURN_LEFT(speed,0);
              Move=1;
          }

          //Winkel erreicht ---> Ende
          if(Move==0)
          {
             MOTOR_STOP();
             DELAY_MS(return_wait);
             break;
          }

  }while(1);

}


